#-*- mode: python; mode: fold -*-
#
#       $Id:  $ #{{{
#
##Copyright (c) 2002 AixtraWare All rights reserved. 
##
##Redistribution and use in source and binary forms, with or without
##modification, are permitted provided that the following conditions
##are met:
##
##1. Redistributions of source code must retain the above copyright
##   notice, this list of conditions and the following disclaimer.
##
##2. Redistributions in binary form must reproduce the above copyright
##   notice, this list of conditions and the following disclaimer in the
##   documentation and/or other materials provided with the distribution.
##
##3. Neither the name of AixtraWare or the names of its contributors  may 
##   be used to endorse or promote products derived from this software 
##   without specific prior written permission
##
##THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
##"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
##LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
##A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL INFRAE OR
##CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
##EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
##PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
##PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
##LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
##NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
##SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

__doc__="""$Id: AixtraNavigation.py $"""

#}}}

from AixtraNavigationInterface import AixtraNavigationInterface
from AccessControl import ClassSecurityInfo, getSecurityManager
from Globals import InitializeClass, DTMLFile
import Globals
from Acquisition import Implicit
from Globals import Persistent
from AccessControl.Role import RoleManager
from OFS.SimpleItem import SimpleItem
from OFS.Folder import Folder
from Products.PythonScripts.PythonScript import manage_addPythonScript
from Products.PageTemplates.ZopePageTemplate import manage_addPageTemplate
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from string import *
import time

file_path = Globals.package_home(globals())

#addForm=DTMLFile('dtml/addForm', globals())
addForm=PageTemplateFile('zpt/addForm', globals())

def addFunction(dispatcher, id, title, order, container_id, function, object_id,  REQUEST=None): #{{{
    """
    Create a new AixtraNavigation and add it to the destination.
    """
    td = {}
    if title == "__multilingual":
	for t in REQUEST.form.keys():
	    if t.startswith("title__"):
		td[t] = REQUEST.get(t)
    p=AixtraNavigation(id, title, td, order, container_id, function, object_id, dispatcher)
    dispatcher.Destination()._setObject(id, p)
    if REQUEST is not None:
        dispatcher.manage_main(dispatcher, REQUEST)

#}}}

class AixtraNavigation(SimpleItem): #{{{
    """
    AixtraNavigation product class, implements AixtraNavigationInterface.

    """
    __implements__=AixtraNavigationInterface

    meta_type='AixtraNavigation'

    mo = (
        {'label' : 'Navigation',
         'action' : 'editNavigationForm',
         'help' : ('AixtraNavigation', 'edit.txt')
         },
        )
    manage_options = mo + SimpleItem.manage_options
    
    security=ClassSecurityInfo()

    def __init__(self, id, title, td, order, container_id, function, object_id,  parent): #{{{
        self.id=id
	self.title = title
	for t in td.keys():
	    setattr(self,t,td[t])
        self.order = order
	try:
	    self.levels = map(int,order.split('.'))
	except ValueError:
	    self.levels = [0,0,0,0]
	l = 0
	for i in range(len(self.levels)):
	    if self.levels[i] == 0:
		break
	    else:
		l += 1
	self.level_nr = l
        self.container_id = container_id
        self.function = function
        self.object_id = object_id
	return 

    #}}}
    
    security.declareProtected('Change AixtraNavigation', 'editAixtraNavigation')
    editNavigationForm=PageTemplateFile('zpt/editForm', globals())
    def editAixtraNavigation(self, title, order, container_id, function, object_id,  REQUEST=None): #{{{
        """Edits the AixtraNavigation"""
	self.title = title
	if title == "__multilingual":
	    for t in REQUEST.form.keys():
		if t.startswith("title__"):
		    setattr(self,t,REQUEST.get(t))
        self.order = order
	self.levels = map(int,order.split('.'))
	l = 0
	for i in range(len(self.levels)):
	    if self.levels[i] == 0:
		break
	    else:
		l += 1
	self.level_nr = l
        self.container_id = container_id
        self.function = function
	self.object_id = object_id
	if not REQUEST is None:  
	    return self.editNavigationForm(REQUEST,
	                                  manage_tabs_message='AixtraNavigation changed.')
    #}}}
    
    def getMultiLingTitle(self,lang):
	"""return title"""
	return getattr(self,"title__%s__" % lang,None)

# Initialize product class
# ------------------------

InitializeClass(AixtraNavigationInterface)
